<script lang="ts">
import { defineComponent } from 'vue'
import Filter from "@/components/Filter.vue";

interface Item {
    id: number
    name: string
    type: string
    weight: number
}

interface SortOption {
    key: string
    direction: 'asc' | 'desc'
}

interface FilterOption {
    key: string
    value: string | string[]
}

interface Fruits {
    data: Item[];
    meta: {
        per_page: number;
        current_page: number;
        last_page: number;
        total: number;
    };
}

export default defineComponent({
    name: 'Datatable',
    components: {Filter},
    data() {
        return {
            fruits: <Fruits> {},
            filters: <FilterOption[]> [],
            sortOption: <SortOption> {}
        }
    },

    methods: {
        async fetchData(page: number = 1) {
            try {
                const res = await this.$axios.get('fruits?page=' + page, {
                    params: {...this.sortOption, ...this.filters}
                });
                this.fruits = <Fruits>res.data
            } catch (e) {
                console.log(e)
            }
        },

        prevPage () {
            if (this.fruits.meta.current_page > 1) {
                this.fetchData(this.fruits.meta.current_page - 1);
            }
        },

        nextPage () {
            if (this.fruits.meta.current_page < this.fruits.meta.last_page) {
                this.fetchData(this.fruits.meta.current_page + 1);
            }
        },

        async sort(field: string) {
            const sortOption: SortOption = {
                key: field,
                direction: 'asc'
            }

            if (this.sortOption?.key === field) {
                sortOption.direction = this.sortOption?.direction === 'asc' ? 'desc' : 'asc'
            }

            this.sortOption = sortOption

            await this.fetchData(this.currentPage)
        },

        async search(filter) {
            if (filter.length === 0) {
                this.sortOption = {}
            }

            this.filters = <FilterOption[]> filter

            await this.fetchData(this.currentPage)
        },
    },

    computed: {
        items() {
            return this.fruits.data
        },
        currentPage() {
            return this.fruits.meta?.current_page
        },
        totalPages() {
            return this.fruits.meta?.last_page
        }
    },

    mounted() {
        this.fetchData()
    }
})
</script>

<template>
    <div class="datatable">
        <Filter @search="search" @clear="search([])" />
        <table>
            <thead>
            <tr>
                <th @click="sort('id')">
                    ID
                    <span v-if="sortOption.key === 'id' && sortOption.direction === 'asc'">↑</span>
                    <span v-if="sortOption.key === 'id' && sortOption.direction === 'desc'">↓</span>
                </th>
                <th @click="sort('name')">
                    Fruit Name
                    <span v-if="sortOption.key === 'name' && sortOption.direction === 'asc'">↑</span>
                    <span v-if="sortOption.key === 'name' && sortOption.direction === 'desc'">↓</span>
                </th>
                <th>
                    Fruit Type
                </th>
                <th @click="sort('weight')">
                    Weight
                    <span v-if="sortOption.key === 'weight' && sortOption.direction === 'asc'">↑</span>
                    <span v-if="sortOption.key === 'weight' && sortOption.direction === 'desc'">↓</span>
                </th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="item in items" :key="item.id">
                <td>{{ item.id }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.type }}</td>
                <td>{{ item.weight }}g</td>
            </tr>
            </tbody>
        </table>
        <div class="pagination">
            <button @click="prevPage" :disabled="currentPage === 1">Previous</button>
            <span>{{ currentPage }} / {{ totalPages }}</span>
            <button @click="nextPage" :disabled="currentPage === totalPages">Next</button>
        </div>
    </div>
</template>
